;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "checkpoint_man.inc"
.include "vueltas_man.inc"
.include "entity_man.inc"
.include "partidas.inc"
.include "strings.inc"

.area _DATA


checkpoint_actual_total_num:.db 0
checkpoint_actual::.dw 1
checkpoint_actual_end:.dw 1


_comprobar_puntos: .db 01

checkpoints_level_1::
.ds level_1_checkpoints*2
.db #0,#0
level_1_checkpoint_data::
;first checkpoint
;.db 64,32;x,y
.db 60,55;x,y
.db 6,34;w,h

;second checkpoint
.db 60,110;x,y
.db 16,18;w,h

;third checkpoint
.db 44,110;x,y
.db 4,34;w,h

;fourth checkpoint
.db 36,160;x,y
.db 12,18;w,h

;fifth checkpoint
.db 10,160;x,y
.db 6,34;w,h

;sixth checkpoint
.db 4,72;x,y
.db 12,18;w,h

;seventh checkpoint
.db 44,55;x,y
.db 6,34;w,h

level_1_checkpoint_end::
.db 0

level_2_checkpoint_data::
;first checkpoint
;.db 64,32;x,y
.db 64,55;x,y
.db 6,34;w,h

;second checkpoint
.db 64,122;x,y
.db 12,18;w,h

;third checkpoint
.db 50,144;x,y
.db 4,34;w,h

;fourth checkpoint
.db 20,144;x,y
.db 4,34;w,h

;fifth checkpoint
.db 4,104;x,y
.db 12,18;w,h

;sixth checkpoint
.db 4,72;x,y
.db 12,18;w,h

;seventh checkpoint
.db 41,55;x,y
.db 6,34;w,h

level_2_checkpoint_end::
.db 0

level_3_checkpoint_data::
;first checkpoint
;.db 64,32;x,y
.db 60,142;x,y
.db 12,18;w,h

;second checkpoint
.db 60,71;x,y
.db 12,18;w,h

;third checkpoint
.db 50,55;x,y
.db 6,34;w,h

;fourth checkpoint
.db 44,84;x,y
.db 12,18;w,h

;fifth checkpoint
.db 44,113;x,y
.db 12,18;w,h

;sixth checkpoint
.db 32,113;x,y
.db 4,34;w,h


;seventh checkpoint
.db 24,71;x,y
.db 12,18;w,h

;eighth checkpoint
.db 16,55;x,y
.db 8,34;w,h

;nineth checkpoint
.db 8,84;x,y
.db 12,18;w,h

;tenth checkpoint
.db 8,158;x,y
.db 12,18;w,h

;eleventh checkpoint
.db 49,158;x,y
.db 6,34;w,h

level_3_checkpoint_end::
.db 0

.area _CODE
checkpoint_man_init::
    call load_first_level
ret

load_first_level:
    ld a, #level_1_checkpoints
    ld (checkpoint_actual_total_num),a
    ld de, #level_1_checkpoint_data
    ld (checkpoint_actual),de
    ld de,#level_1_checkpoint_end
    ld (checkpoint_actual_end),de
    ; ld hl, #checkpoints_level_1
    ; bucle_level_1:
    ; ld (hl),e
    ; inc hl
    ; ld (hl),d
    ; sub #1
    ; ret z
    ; inc hl
    ; .rept 4
    ;   inc de
    ; .endm
    ; jr bucle_level_1
ret

load_second_level::
    ld a, #level_2_checkpoints
    ld (checkpoint_actual_total_num),a
    ld de, #level_2_checkpoint_data
    ld (checkpoint_actual),de
    ld de,#level_2_checkpoint_end
    ld (checkpoint_actual_end),de
ret

load_third_level::
    ld a, #level_3_checkpoints
    ld (checkpoint_actual_total_num),a
    ld de, #level_3_checkpoint_data
    ld (checkpoint_actual),de
    ld de,#level_3_checkpoint_end
    ld (checkpoint_actual_end),de
ret

pintar_checkpoints::;;para probar checkpoints, tiene que ser borrado
  ;ld l, (checkpoints_level_1)
  ;ld h, (checkpoints_level_1+1)
  ld ix, (checkpoint_actual)
  ld a,(checkpoint_actual_total_num)
  ; (2B DE) memory	Video memory pointer to the upper left box corner byte
  ; (1B A ) colour_pattern	1-byte colour pattern (in screen pixel format) to fill the box with
  ; (1B C ) width	Box width in bytes [1-64] (Beware!  not in pixels!)
  ; (1B B ) height	Box height in bytes (>0)
  bucle_pintar_checkpoints:
  push af
  ld de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
  ld a,chkpnt_y(ix)
  ld b,a
  ld a,chkpnt_x(ix)
  ld c,a
  call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
  
  ex de,hl
  ld a,chkpnt_h(ix)
  ld b,a
  ld a,chkpnt_w(ix)
  ld c,a
  ld a,#0xff
  call cpct_drawSolidBox_asm

  ld bc,#4
  add ix,bc
  pop af
  dec a
  ret z
  jr bucle_pintar_checkpoints

ret

asignar_checkpoint::
  ld hl,(checkpoint_actual)
  ld car_checkpoint_siguiente(ix), l
  ld car_checkpoint_siguiente+1(ix), h
ret
checkpoint_update_for_one_entity:
  ld l,car_checkpoint_siguiente(ix)
  ld h,car_checkpoint_siguiente+1(ix)

  ld d,(hl);;cp x
  inc hl
  inc hl
  ld a,(hl)
  ld c,a  ;;cp w

  ; ld a,(hl) 
  ;ld b,d  ;; b= chk point x
  ld a,car_x(ix)
  add car_w(ix);; a= car x + car_w
  sub #1
  cp d ;;car_x + car_w > chk point x
  jr c,end_checkpoint_update


  ld a,car_x(ix)
  ;add car_w(ix)
  ld b,a  ;; b= car x
  ld a,d ;; a= chk point x
  add c
  sub #1
  cp b ;;car_x < chk point x + chk point w
  jr c,end_checkpoint_update

  dec hl ;; chk point y
  ;inc hl;;y
  ld d,(hl);;cp y
  inc hl
  inc hl
  ld a,(hl)
  ld c,a  ;;cp h

  ; ; ld a,(hl) 
  ; ; ld b,a  ;; b= chk point y
  ld a,car_y(ix)
  add car_h(ix);; a= car y + car_h
  sub #1
  cp d ;;car_y + car_H > chk point y
  jr c,end_checkpoint_update

  ld a,car_y(ix)
  ;add car_h(ix)
  ld b,a  ;; b= car y
  ld a,d ;; a= chk point y
  add c
  sub #1
  cp b ;;car_y < chk point y + chk point h
  jr c,end_checkpoint_update
  ;;
  ;;
  ;; hasta aqui ha comprobado si hay colision con el checkpoint, si la hay, cambia al siguiente
  ;;
  ;;


  ;call sumarpuntos


  ld l,car_checkpoint_siguiente(ix)
  ld h,car_checkpoint_siguiente+1(ix)
  ld d,#0
  ld e,#4
  add hl,de
  
  ld car_checkpoint_siguiente(ix),l
  ld car_checkpoint_siguiente+1(ix),h
  ld de,(checkpoint_actual_end)
  ld a,d
  cp h
  jr nz,end_checkpoint_update
  call sumarpuntos
  
  ld a,e
  cp l
  jr nz,end_checkpoint_update
  
  
  call asignar_checkpoint
  
  ;Funciona bn para el siguiente chk de enfrente del coche, hay que cambiar la posicion donde empieza



  ;.db 0xED, 0xFF
  call playerOia2
  ld a,car_num_coche(ix)
  cp #1
  jr nz,no_player_vuelta
  call aumentar_vuelta_verde
  no_player_vuelta:
  ld a,car_vuelta_actual(ix)
  inc a
  ld car_vuelta_actual(ix),a
  cp #num_vueltas
  jr nz,end_checkpoint_update
  
  call playerOia
  ;call pintar_checkpoints
  end_checkpoint_update:
  
  ;call cuentoLaps
  
  ld iy,#return_entity_man_all_entities
  jp (iy)

  
ret

playerOia2:

  ld a,car_num_coche(ix)
  cp #1
  ;jp z,ganao
  jp z,cuentoLaps
  

ret

playerOia:

ld a,car_num_coche(ix)
cp #1
jp z,ganao
;jp z,cuentoLaps
cp #2
jp z,pierdePlayer
;jp z, cuentoLapsEnemigo

ret


checkpoint_update::
  ;.db 0xED, 0xFF
  ld iy,#checkpoint_update_for_one_entity
  call entity_man_all_entities
ret

get_checkpoints_for_ai::
  ;e:x 
  ;b:y
  ld l,car_checkpoint_siguiente(ix)
  ld h,car_checkpoint_siguiente+1(ix)
  ld e,(hl);;checkpoint x
  inc hl
  ld b,(hl);;checkpoint y
  inc hl
  ld a,(hl);;checkpoint w
  srl a    ;;checkpoint w/2
  add e    ;;checkpoint x+(w/2)
  ld e,a 
  inc hl  
  ld a,(hl);;checkpoint h
  srl a    ;;checkpoint h/2
  add b    ;;checkpoint y+(h/2)
  ld b,a
ret


;;
;;OUTPUT
;;HL: DIRECCION DE MEMORIA DEL SIGUIENTE CHECKPOINT A COMPROBAR
;;
get_next_checkpoint_for_ai::
  ld l,car_checkpoint_siguiente(ix)
  ld h,car_checkpoint_siguiente+1(ix)
  ld d,#0
  ld e,#4
  add hl,de
  
  ld de,(checkpoint_actual_end)
  ld a,d
  cp h
  ret nz
  ;.db 0xED, 0xFF
  ld a,e
  cp l
  ret nz
  ld hl,(checkpoint_actual)
  ;call cuentoLapsEnemigo
ret


;;INPUT
;;HL: direccion de memoria a current checkpoint
;;OUT
;;HL: direccion de memoria a siguiente checkpoint
get_next_checkpoint_for_ai_2::
  ; ld l,car_checkpoint_siguiente(ix)
  ; ld h,car_checkpoint_siguiente+1(ix)
  ld d,#0
  ld e,#4
  add hl,de
  
  ld de,(checkpoint_actual_end)
  ld a,d
  cp h
  ret nz
  ;.db 0xED, 0xFF
  ld a,e
  cp l
  ret nz
  ld hl,(checkpoint_actual)
  ;call cuentoLapsEnemigo
ret