;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "partidas.inc"
.include "entity_man.inc"
.include "sys/input_sys.inc"
.include "cpctelera.h.s"
.include "animation_man.inc"
.include "checkpoint_man.inc"
.area _DATA
;;
c_components::;;puntero a la velocidad
.ds c_components_size * c_total_number
; .dw 1
; .dw 1 ;x, y
; .dw 1 ;x, y 256
; .dw 1 ;w,h
; .dw 1 ;prev_pos
; .dw 1 ;sprite
; .dw 1 ;prev_sprite
; .dw 1 ;tile x izq, tile y arriba
; .dw 1 ;tile x der, tile y abajo
; .dw 1 ;id tile up left id tile up right
; .dw 1 ;id tile down left, id tile down right
; .dw 1 ;pressed_key, pressed_avanzar
; .ds 1 ;contador avanzar
; .dw 1 ;checkpoint siguiente
; .ds 1 ;vuelta actual

;;velocidades por angulos
;vel_actual::.db 0;;0: x e y=0;; 1: primera vel;; 2: segunda vel;; 3: tercera vel
;vel_punt::.db 0;;0: punt 1;;1: punt 2;;2: punt 3
velocidades_begin::
.db #end_of_vel,#end_of_vel;;Para controlar el final
.db #end_of_vel,#end_of_vel;;Para controlar el final
.db #end_of_vel,#end_of_vel;;Para controlar el final
velocidades::
.db #vel_default_x,#vel_0   ;;angulo 0
.db #vel_default_x_1,#vel_0   ;;angulo 0 + acel
.db #vel_default_x_2,#vel_0   ;;angulo 0 + acel 2

vel_30::
.db #vel_30_x,#-vel_30_y  ;;angulo 30
.db #vel_30_x_1,#-vel_30_y_1  ;;angulo 30
.db #vel_30_x_2,#-vel_30_y_2  ;;angulo 30


vel_60::
.db #vel_60_x,#-vel_60_y  ;;angulo 60
.db #vel_60_x_1,#-vel_60_y_1  ;;angulo 60
.db #vel_60_x_2,#-vel_60_y_2  ;;angulo 60

vel_90::
.db #vel_0,#-vel_default_y  ;;angulo 90
.db #vel_0,#-vel_default_y_1  ;;angulo 90
.db #vel_0,#-vel_default_y_2  ;;angulo 90


vel_120::
.db #-vel_60_x,#-vel_60_y  ;;angulo 120
.db #-vel_60_x_1,#-vel_60_y_1  ;;angulo 120
.db #-vel_60_x_2,#-vel_60_y_2  ;;angulo 120


vel_150::
.db #-vel_30_x,#-vel_30_y  ;;angulo 150
.db #-vel_30_x_1,#-vel_30_y_1  ;;angulo 150
.db #-vel_30_x_2,#-vel_30_y_2  ;;angulo 150


vel_180::
.db #-vel_default_x,#vel_0  ;;angulo 180
.db #-vel_default_x_1,#vel_0  ;;angulo 180
.db #-vel_default_x_2,#vel_0  ;;angulo 180


vel_210::
.db #-vel_30_x,#vel_30_y  ;;angulo 210 
.db #-vel_30_x_1,#vel_30_y_1  ;;angulo 210 
.db #-vel_30_x_2,#vel_30_y_2  ;;angulo 210 


vel_240::
.db #-vel_60_x,#vel_60_y  ;;angulo 240
.db #-vel_60_x_1,#vel_60_y_1  ;;angulo 240
.db #-vel_60_x_2,#vel_60_y_2  ;;angulo 240

vel_270::
.db #vel_0,#vel_default_y   ;;angulo 270
.db #vel_0,#vel_default_y_1   ;;angulo 270
.db #vel_0,#vel_default_y_2   ;;angulo 270


vel_300::
.db #vel_60_x,#vel_60_y  ;;angulo 300
.db #vel_60_x_1,#vel_60_y_1  ;;angulo 300
.db #vel_60_x_2,#vel_60_y_2  ;;angulo 300

vel_330::
.db #vel_30_x,#vel_30_y  ;;angulo 330
.db #vel_30_x_1,#vel_30_y_1  ;;angulo 330
.db #vel_30_x_2,#vel_30_y_2  ;;angulo 330

velocidades_end::
.db #end_of_vel,#end_of_vel;;Para controlar el final
.db #end_of_vel,#end_of_vel;;Para controlar el final
.db #end_of_vel,#end_of_vel;;Para controlar el final


.area _CODE

entity_man_init::
    call car_init_any_car
    call car_init_player_car
    call car_init_rival_car
    ret
car_init_any_car:
    ld a, #0
    ld ix,#c_components
    bucle_init_any_car:
    push af
    ld a,#15
    ld car_x(ix),a
    ld a,#40
    ld car_y(ix),a
    ld a,#PLAYER_CAR_W
    ld car_w(ix),a
    ld a,#PLAYER_CAR_H
    ld car_h(ix),a
    ld a,#0
    ld car_pressed_key(ix),a
    ld car_pressed_avanzar(ix),a
    ld car_contador_avanzar(ix),a
    ld car_vuelta_actual(ix),a
    ld car_vel_actual(ix),a
    ld car_vel_punt(ix),a
    ld car_iguales_choque_left(ix),a
    ld car_collision_cont(ix),a
    ld car_x_256(ix),a
    ld car_y_256(ix),a

    ld hl,#(velocidades)
    ld car_vel(ix),l
    ld car_vel+1(ix),h


    ld de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld a,car_y(ix)
    ld b,a
    ld a,car_x(ix)
    ld c,a
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ld car_prev_pos(ix),l
    ld car_prev_pos+1(ix),h

    call asignar_checkpoint
    ld d,#0
    ld e,#c_components_size
    add ix,de
    pop af
    inc a
    cp #2
    jr nz,bucle_init_any_car
ret

coords_player:
    ld a,(_nivel_actual)
    cp #0
    jr nz, next_level_1
    ld a,#c_coords_x_lvl_1
    ld car_x(ix),a
    ld a,#c_coords_y_lvl_1
    ld car_y(ix),a
    ret
    next_level_1:
    cp #1
    jr nz, next_level_2
    ld a,#c_coords_x_lvl_2
    ld car_x(ix),a
    ld a,#c_coords_y_lvl_2
    ld car_y(ix),a
    ret
    next_level_2:
    ld a,#c_coords_x_lvl_3
    ld car_x(ix),a
    ld a,#c_coords_y_lvl_3
    ld car_y(ix),a
ret


coords_ai:
    ld a,(_nivel_actual)
    cp #0
    jr nz, next_level_1_ai
    ld a,#c_coords_x_lvl_1_ai
    ld car_x(ix),a
    ld a,#c_coords_y_lvl_1_ai
    ld car_y(ix),a
    ret
    next_level_1_ai:
    cp #1
    jr nz, next_level_2_ai
    ld a,#c_coords_x_lvl_2_ai
    ld car_x(ix),a
    ld a,#c_coords_y_lvl_2_ai
    ld car_y(ix),a
    ret
    next_level_2_ai:
    ld a,#c_coords_x_lvl_3_ai
    ld car_x(ix),a
    ld a,#c_coords_y_lvl_3_ai
    ld car_y(ix),a
ret
car_init_player_car:
    ld ix,#c_components
    call coords_player
    
    ld de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld a,car_y(ix)
    ld b,a
    ld a,car_x(ix)
    ld c,a
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ld car_prev_pos(ix),l
    ld car_prev_pos+1(ix),h

    ld hl,#player_sprites
    ld car_sprite(ix),l
    ld car_sprite+1(ix),h
    ld car_prev_sprite(ix),l
    ld car_prev_sprite+1(ix),h

    ld a,#1
    ld car_num_coche(ix),a
ret
car_init_rival_car:
    call entity_man_get_ia_to_ix
    call coords_ai
    
    ld de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
    ld a,car_y(ix)
    ld b,a
    ld a,car_x(ix)
    ld c,a
    call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ld car_prev_pos(ix),l
    ld car_prev_pos+1(ix),h

    ld hl,#rival_sprites
    ld car_sprite(ix),l
    ld car_sprite+1(ix),h
    ld car_prev_sprite(ix),l
    ld car_prev_sprite+1(ix),h
    ld a,#2
    ld car_num_coche(ix),a
ret

check_contador_giros::
   ld a,car_pressed_key(ix)
   cp #max_contador_giros
   jr nz,add_contador
   ld a,#0
   ld car_pressed_key(ix),a
   ret
   add_contador:
   ld b,#1
   ld a,car_pressed_key(ix)
   add b
   ld car_pressed_key(ix),a
   ret


;;
;;
;;INPUT: IY = direccion de memoria a la que saltar
;;
entity_man_all_entities::
    ld ix,#c_components
    while_entity_forall:;;bucle que va actualizando cada entidad
    
    ;return_entity_man_all_entities::.db #bucle_entity_for_all
    ;ld IY, #. + 6
    push iy
    jp (iy)
    return_entity_man_all_entities::
    pop iy
    ;call _sys_render_update_one_entity
    ld a,car_num_coche(ix)
    cp #c_total_number
    ret z;;en caso de haber llegado al max de coches, hace ret
    ld bc,#c_components_size;;para avanzar una entidad hay que sumar 5
    add ix,bc
    jr while_entity_forall
ret


entity_man_get_ia_to_ix::
    ;call entity_man_get_ia_to_ix 
    ld ix,#c_components
    ld bc,#c_components_size
    add ix,bc
ret

;;OUTPUT
;;HL:direccion de memoria a la anterior velocidad
entity_man_get_der_vel::
    ld l,car_vel(ix)
    ld h,car_vel+1(ix)
    ld e,#-vel_size
    ld d,#0xFF
    add hl,de

    ld a,(hl)
    cp #end_of_vel
    ret nz
    ld hl,#(velocidades_end-vel_size)
    ld a,car_vel_punt(ix)
    add a
    ld c,a
    ld b,#0
    add hl,bc
ret
;;OUTPUT
;;HL:direccion de memoria a la anterior velocidad
entity_man_get_izq_vel::
    ld l,car_vel(ix)
    ld h,car_vel+1(ix)
    ld de,#vel_size
    add hl,de
    
    ld a,(hl)
    cp #end_of_vel
    ret nz
    ld hl,#velocidades
    ld a,car_vel_punt(ix)
    add a
    ld c,a
    ld b,#0
    add hl,bc
ret