;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "man/entity_man.inc"
.include "sys/input_sys.inc"
.include "sys/ai_sys.inc"
.include "sys/render_sys.inc"
.include "sys/physics_sys.inc"
.include "sys/collision_sys.inc"
.include "man/strings.inc"
.include "man/checkpoint_man.inc"
.include "man/menu.inc"
.include "man/partidas.inc"
.include "sys/ai_sys.inc"
.include "man/referencia_man.inc"
.include "man/vueltas_man.inc"


.globl cpct_disableFirmware_asm
.globl cpct_waitVSYNC_asm

.globl cpct_akp_stop_asm

.area _CODE

iniciar_todo::
   call menu_init
   call menu_update
   ;se sale del update una vez hay juego, luego llama a entidades
   ;call sys_render_init
   ;call entity_man_init
   call checkpoint_man_init
   call inicioNiveles
   
   call sys_render_init
   ;call entity_man_init
   call sys_collision_init
   ;call sys_render_update_first_time
   
   ;call pintar_checkpoints
   call ai_sys_init
   
   call initlaps
   call puntos
   call referenciaInit   
   
   call cuadrados_init
ret

juego::
   
   call cpct_akp_stop_asm

   call input
   call ai_sys_update
   call sys_physics_update
   ;call partida_update
   call sys_collision_update
   ;call initlaps
   ;call cambiolaps
   ;call managerpuntos
   ; .rept 3
   ;    halt
   ;    halt
      call cpct_waitVSYNC_asm
   ;.endm
   call sys_render_update
   call checkpoint_update
   call cambiolaps
    ;call managerpuntos
   ;call menu_update
   
   ;call check_pressed_avanzar;;para comprobar un error, borrar luego
   jr    juego
