;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "menu.inc"
.include "sys/render_sys.inc"
.include "src/man/prueba_z.h.s"
.include "src/man/prueba2_z.h.s"
.include "src/man/pruebafinal_z.h.s"
.include "src/man/hasganaoFinal.h.s"
.include "src/man/hasganao_z.h.s"
.include "src/man/hasperdio_z.h.s"
.include "src/man/partidas.inc"
.include "src/man/game.inc"
.include "src/man/strings.inc"

.area _DATA
vueltas2:   .db 'L','A','P','S',':','2','/','5','\0' 
_salir:: .db 0
.area _CODE

menu_init::

    ld a,#0
    call nivelesa0
    call sys_render_init
    cpctm_setBorder_asm HW_BLACK
    ;Descomprimo una imagen en memoria de video, y la lleno con esta imagen
    ;ld  hl, #_prueba_z_end
    ;ld hl,#_prueba2_z_end
    ld hl,#_pruebafinal_z_end
    ld  de, #0xFFFF
    ;FFFF es el ultimo byte de memoria de video, para que sea la ultima parte de donde quiero descomprimirlo
    call  cpct_zx7b_decrunch_s_asm
    
    ;call puntuacionAnteriorMapa
    call menu_jugar

ret

menu_init2::

    push hl
    push de
    ld de, #_game_song
    call cpct_akp_musicInit_asm
    pop de
    pop hl

    ld a,#0
    call nivelesa0
    ;call sys_render_init
    cpctm_setBorder_asm HW_BLACK
    ld hl,#_pruebafinal_z_end
    ld  de, #0xFFFF
    
    call  cpct_zx7b_decrunch_s_asm
    call menu_update

    call    cpct_scanKeyboard_f_asm
    ld hl,#Key_1
    call cpct_isKeyPressed_asm
    jr nz, menu_jugar

    jr menu_init2
ret

menu_init3::

    push hl
    push de
    ld de, #_game_song
    call cpct_akp_musicInit_asm
    pop de
    pop hl

    ld a,#0
    call nivelesa0
    ;call sys_render_init
    cpctm_setBorder_asm HW_BLACK
    ld hl,#_pruebafinal_z_end
    ld  de, #0xFFFF
    
    call  cpct_zx7b_decrunch_s_asm
    call menu_update

    call    cpct_scanKeyboard_f_asm
    ld hl,#Key_1
    call cpct_isKeyPressed_asm
    jp nz, cargarMapa1

    jr menu_init3
ret



menu_update:
  
    call cpct_waitVSYNC_asm
    call cpct_akp_musicPlay_asm

    call    cpct_scanKeyboard_f_asm
    ld hl,#Key_1
    call cpct_isKeyPressed_asm
    ;jr nz, menu_jugar
    ret nz

    call    cpct_scanKeyboard_f_asm
    ld hl,#Key_2
    call cpct_isKeyPressed_asm
    jr nz,menu_ayuda

    jr menu_update
menu_jugar:
    ;call juego

    call nivelesa0
    
    ld a,(_salir)
    inc a
    ld (_salir),a
   

    ret

menu_ayuda:
;AQUI PONER LA IMAGEN DE CONTROLES
    ld hl,#_prueba_z_end
    ld  de, #0xFFFF
    call  cpct_zx7b_decrunch_s_asm

    call control_ayuda

ret

control_ayuda:

    call cpct_waitVSYNC_asm
    call cpct_akp_musicPlay_asm
   
    call    cpct_scanKeyboard_f_asm
    ld hl,#Key_Esc
    call cpct_isKeyPressed_asm
    jp nz,menu_init2

    jr control_ayuda

menu_hasganao::

    call cpct_akp_stop_asm

    ;call sys_render_init
    cpctm_setBorder_asm HW_GREEN
    ld hl,#_hasganao_z_end
    ld  de, #0xFFFF
    call  cpct_zx7b_decrunch_s_asm

    call    cpct_scanKeyboard_f_asm
    ld hl,#Key_1
    call cpct_isKeyPressed_asm
    ret nz

    jr menu_hasganao

menu_hasganao_final::

   
    cpctm_setBorder_asm HW_GREEN
    ld hl,#_hasganao_z_end
    ld  de, #0xFFFF
    call  cpct_zx7b_decrunch_s_asm

    call compruebofinal
   ret

compruebofinal:
    call finalfinal

    call    cpct_scanKeyboard_f_asm
    ld hl,#Key_1
    call cpct_isKeyPressed_asm
    jp z, compruebofinal

   call vuelvomenu
    .db 0xED,0xFF
ret

salida0:
    ld a,#0
    ld (_salir),a
    ret

salida1:
    ld a,#1
    ld (_salir),a
     ;call calculoNivel
    ret

salida2:
    ld a,#2
    ld (_salir),a
    ;call estadoJuego
    ret

menu_pierdes::

    call cpct_akp_stop_asm

    call salida0

    cpctm_setBorder_asm HW_RED

    ld hl,#_hasperdio_z_end
    ld  de, #0xFFFF
    call  cpct_zx7b_decrunch_s_asm

    call    cpct_scanKeyboard_f_asm
    ld hl,#Key_1
    call cpct_isKeyPressed_asm
    jr nz,salida1

    ;call vuelvomenu
     call    cpct_scanKeyboard_f_asm
    ld hl,#Key_2
    call cpct_isKeyPressed_asm
    jp nz,menu_init2
    
    ld a,(_salir)
    cp a,#0
    ret nz
    jr menu_pierdes
ret

vuelvomenu::
    .db 0xED,0xFF
    call iniciar_todo
    ; call    cpct_scanKeyboard_f_asm
    ; ld hl,#Key_2
    ; call cpct_isKeyPressed_asm
    ; jp nz, menu_init

    ;jr menu_update

ret


