;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "sys/render_sys.inc"
.include "sys/ai_sys.inc"
.include "man/entity_man.inc"
.include "man/vueltas_man.inc"
.include "man/checkpoint_man.inc"
.include "partidas.inc"
.include "strings.inc"
.include "menu.inc"

.area _DATA
;_entity_gana::.dw 1
_nivel_actual::.db 1
_vuelta_enemigo::.db 1
_iy_actual:: .dw 1
_ix_actual:: .dw 1

estado:: .db 0
_vuelta_actual:: .db 1
nivel_0 = 0
color = 0x0606
color2 = 0xFFFF
.area _CODE
;con 1 se acaba
;con 0 sigue el juego
estadoJuego::
  ld hl, #estado
  ld  a, (hl)

  cp a,#0
  jp menu_init


  ret

inicioNiveles::

;cargo en a el nivel actual, que al principio es 1, luego aumento
    
    ld    a, #nivel_0
    ld    (_nivel_actual), a

    ;ld d,#_nivel_actual
    ;con esto de arriba, nivel actual vale 63 en vez de 1
    cp a, #0
    jr z,cargarMapa1
      
ret

lapsinicial:
  ld a,#0
  ld (_vuelta_actual),a

ret

nivelesa0::

  ld    a, #nivel_0
  ld    (_nivel_actual), a

ret
calculoNivel::

  ld    (_nivel_actual), a
  cp a, #0
    jr z,cargarMapa1
   ; call partida_update
    ld  a,(_nivel_actual)
    ;ld d,#_nivel_actual
    cp	a, #1
    jr	z, cargarMapa2

    ld  a,(_nivel_actual)
    cp	a, #2
    jr	z, cargarMapa3

    ld  a,(_nivel_actual)
    cp	a, #3
    jp	z, ganasfinal

    ret

siguienteNivel::

;sumo un nivel
  
  ld a,(_nivel_actual)
  inc a
  ld (_nivel_actual),a
  call calculoNivel
  ;call pintar_checkpoints
  ; call sys_render_update_first_time
  ; call cuadrados_init
  

ret
cargarMapa1::
    
    ;call sys_render_init
    call lapsinicial
    call initlaps
  call tilemap1
  ;call load_second_level
  ;call sys_render_init
  call checkpoint_man_init
  call entity_man_init
  call ai_sys_init
  call sys_render_update_first_time
  call cuadrados_init

   cpctm_setBorder_asm HW_BLACK
   call cuentoVueltas
   ;call initlaps
   ;call cambiolaps
    ;call managerpuntos
    call cambio0
    call puntos
   ;call initlaps
    ;call cuentoTiempo
    ;call cargarMapa1
ret
cargarMapa2::
  call lapsinicial
    call initlaps
    call tilemap2
    call load_second_level
    ;call sys_render_init
    call entity_man_init
    call ai_sys_init
    call sys_render_update_first_time
    call cuadrados_init
    cpctm_setBorder_asm HW_BLACK
    call cuentoVueltas
   ;call initlaps
   ;call cambiolaps
    ;call managerpuntos
    call cambio0
    call puntos
  ;call initlaps
    
    
ret
cargarMapa3::
call lapsinicial
    call initlaps
    call tilemap3
    call load_third_level
    call entity_man_init
    call ai_sys_init
    call sys_render_update_first_time
    call cuadrados_init
    cpctm_setBorder_asm HW_BLACK

    call cuentoVueltas
   ;call initlaps
    call cambiolaps
    ;call managerpuntos
    call cambio0
    call puntos
    ;call initlaps
    ;ld a, #_nivel_actual
    ;inc a
ret


ganaPlayer::
;sumar nivel_actual

  ld hl, #estado
  ld (hl), #1

  call inicioNiveles


initlaps::

  call cambio0

ret

initpuntos::

  call puntos
  

ret


cambiolaps::

ld a,(_vuelta_actual)

  cp a,#1
  jp z,cambio1
  
  cp a,#2
  jp z,cambio2
  
  cp a,#3
  jp z,cambio3

  cp a,#4
  jp z,cambio4

  cp a,#5
  jp z,cambio5
    
ret


partidaTerminada::

ld a,#0
ld (_vuelta_actual), a
ld (_vuelta_enemigo),a
ret

partida_update::

    
;   DAR MUY RAPIDO A LA TECLA
  call    cpct_scanKeyboard_f_asm
  ld hl,#Key_0
  call cpct_isKeyPressed_asm
  jp nz,siguienteNivel
   ret 
  


cuentoVueltas::

  ; call    cpct_scanKeyboard_f_asm
  ;   ld hl,#Key_L
  ;  call cpct_isKeyPressed_asm
    
  ;   jp nz, cuentoLaps
    
ret

cuentoVueltasEnemigo::

    call  cpct_scanKeyboard_f_asm
    ld hl,#Key_P
    call cpct_isKeyPressed_asm
    jr nz,cuentoLapsEnemigo
  
    
ret

ganasfinal::

  call partidaTerminada
  ;call puntuacionAnteriorMapa2
  call menu_hasganao_final
  ;call siguienteNivel
  ;call initpuntos
  ;call menu_init2

ret


ganao::
  call partidaTerminada
  call menu_hasganao
  call siguienteNivel
  call puntuacionAnteriorMapa2
  call puntos
  call cambio0
  
  ;call initpuntos
  ret

cuentoLaps::
  
    ;call colorvueltas
    ld a,(_vuelta_actual)
    inc a
    ld (_vuelta_actual),a
    push ix
    call cambiolaps
    pop ix
    ;cp a,#3
    ;cp a,#6
    ;6 son 3 vueltas, añadir 2 por cada vuelta 
    ;jr z, ganao
    ret
pierdePlayer::
  call partidaTerminada
  call menu_pierdes
  ;call puntuacionAnteriorMapa
  
  cp a,#1
  jp z,resetnivel
  cp a,#2
  jp z,menu_init

  ret

resetnivel:

 ld   a,(_nivel_actual)
 call calculoNivel
 ;esto
 ;call puntuacionAnteriorMapa
 call manageoperder

 ret


cuentoLapsEnemigo::

    ld a,(_vuelta_enemigo)
    inc a
    ld (_vuelta_enemigo),a

    cp a,#3
    ;6 son 3 vueltas, añadir 2 por cada vuelta 
    jr z, pierdePlayer
  
    ret


