;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "strings.inc"
.include "src/man/partidas.inc"
.include "man/entity_man.inc"

.area _DATA
string_vueltas:  .db 'L','A','P','S',':','0','/','5','\0' 
vueltas0:   .db 'L','A','P','S',':','0','/','5','\0' 
vueltas1:   .db 'L','A','P','S',':','1','/','5','\0' 
vueltas2:   .db 'L','A','P','S',':','2','/','5','\0' 
vueltas3:   .db 'L','A','P','S',':','3','/','5','\0' 
vueltas4:   .db 'L','A','P','S',':','4','/','5','\0' 
vueltas5:   .db 'L','A','P','S',':','5','/','5','\0' 
final:   .db 'F','I','N','A','L',' ','P','O','I','N','T','S','\0' 

_puntos:    .db 'P','T','S',':','\0' 
_puntuacion:   .db '0','0','0','0','\0' 
_variable:   .db '0','0','0','0','\0' 
_ha_perdido: .db 01
_contador:.db 01

.area _CODE

finalfinal::

 call colorvueltas
  ld   de, #0xC000
  ld c,#0x55
  ld b,#0
  call cpct_getScreenPtr_asm
  ld iy,#final

  call cpct_drawStringM0_asm

  call managerpuntos

ret

sumosobre::

ld a,(_puntuacion + 0)
  inc a
  ld (_puntuacion + 0),a

ret

manageoperder::

  call restoperder
  ld a,(_contador)
  dec a
  dec a
  dec a
  dec a
  dec a
  ld (_contador),a

ret

restoperder:

  ld a,(_puntuacion + 1)
  cp a,#48
  jr z, quitomiles
  ld a,(_puntuacion + 1)
  dec a
  ld (_puntuacion + 1),a
  ld a,(_contador)
  cp a,#4
  ret z
  inc a
  ld (_contador),a
  jr restoperder


ret

quitomiles:

  ld a,(_puntuacion + 0)
  cp a,#48
  ret z
  dec a
  ld (_puntuacion + 0),a
  ld a,#57
  ld (_puntuacion + 1),a
  ld a,(_contador)
  inc a
  ld (_contador),a
  

ret

sumarpuntos::
  ld a,car_num_coche(ix)
  cp #2
  ret z
  ld a,(_puntuacion + 2)
  ;en Hexadecimal 
  cp a,#53
  jr z, decenas5
  ld a,(_puntuacion + 2)
  inc a
  inc a
  inc a
  inc a
  inc a
  ld (_puntuacion + 2),a
  
ret

puntuacionAnteriorMapa::
  
  ;meto la anterior en puntuacion
  ld a,(_variable + 0)
  ld (_puntuacion + 0),a

  ld a,(_variable + 1)
  ld (_puntuacion + 1),a

  ld a,(_variable + 2)
  ld (_puntuacion + 2),a

  ld a,(_variable + 3)
  ld (_puntuacion + 3),a

ret

puntuacionAnteriorMapa2::

  ;meto la anterior en puntuacion
  ld a,(_puntuacion + 0)
  ld (_variable + 0),a

  ld a,(_puntuacion + 1)
  ld (_variable + 1),a

  ld a,(_puntuacion + 2)
  ld (_variable + 2),a

  ld a,(_puntuacion + 3)
  ld (_variable + 3),a

ret


decenas5:
  ;Para cambiar las centenas
  ld a,(_puntuacion + 1)
  cp a,#57
  jr z, miles
 
  ld a,(_puntuacion + 1)
  inc a
  ld (_puntuacion + 1),a
  ld a,#48
  ld (_puntuacion + 2),a
  ret

miles:
  ;Para los miles
  ld a,(_puntuacion + 0)
  inc a
  ld (_puntuacion + 0),a
  call centenas0
ret
centenas0:
  ;Para los miles
  ;ld a,(_puntuacion + 1)
  ld a,#48
  ld (_puntuacion + 1),a
  ld (_puntuacion + 2),a

ret

managerpuntos::
    
    call colorvueltas
    ;call puntuacionAnteriorMapa
    ld   de, #0xC000
    ld c,#0x86
    ld b,#0
    call cpct_getScreenPtr_asm
    ld iy,#_puntuacion
    call cpct_drawStringM0_asm


ret


puntos::
    ; call colorvueltas
    ; ld   de, #0xC000
    ; ld c,#0xF6
    ; ld b,#0xC0
    ; call cpct_getScreenPtr_asm
    ; ld iy,#_puntos

    ; call cpct_drawStringM0_asm
    ret

colorvueltas::
    ;ld l ,#0xff
    ld h,#0x010F
    call cpct_setDrawCharM0_asm
    ret

cambio0::

;  call colorvueltas
;   ld   de, #0xC000
;   ld c,#0xD4
;   ld b,#0xC0
;   call cpct_getScreenPtr_asm
;   ld iy,#vueltas0

  ;call cpct_drawStringM0_asm
  ret

cambio1::

;  call colorvueltas
;   ld   de, #0xC000
;   ld c,#0xD4
;   ld b,#0xC0
;   call cpct_getScreenPtr_asm
;   ld iy,#vueltas1

  ;call cpct_drawStringM0_asm
  ret

cambio2::

;  call colorvueltas
;   ld   de, #0xC000
;   ld c,#0xD4
;   ld b,#0xC0
;   call cpct_getScreenPtr_asm
;   ld iy,#vueltas2

  ;call cpct_drawStringM0_asm
  ret

cambio3::

;  call colorvueltas
;   ld   de, #0xC000
;   ld c,#0xD4
;   ld b,#0xC0
;   call cpct_getScreenPtr_asm
;   ld iy,#vueltas3

  ;call cpct_drawStringM0_asm
  ret


cambio4::

;  call colorvueltas
;   ld   de, #0xC000
;   ld c,#0xD4
;   ld b,#0xC0
;   call cpct_getScreenPtr_asm
;   ld iy,#vueltas4

  ;call cpct_drawStringM0_asm
  ret


cambio5::

;  call colorvueltas
;   ld   de, #0xC000
;   ld c,#0xD4
;   ld b,#0xC0
;   call cpct_getScreenPtr_asm
;   ld iy,#vueltas5

  ;call cpct_drawStringM0_asm
  ret

