;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "ai_sys.inc"
.include "man/partidas.inc"
.include "man/entity_man.inc"
.include "man/checkpoint_man.inc"
.include "man/animation_man.inc"
.include "input_sys.inc"
.include "physics_sys.inc"
.area _DATA
distancia_der_pos:.db 0
distancia_actual_pos:.db 0
distancia_izq_pos:.db 0

checkpoint_a_comprobar:.db 0,0

distancia_x_ai:.db 0
distancia_y_ai:.db 0

decision_ai_timer:: .db 0

current_ai_vel: .dw 1

max_decision_timer: .db #max_decision_timer_lvl_1

velocidades__ai_begin::
.db #end_of_vel_ai,#end_of_vel_ai;;Para controlar el final

velocidades_ai::
.db #vel_ai_default_x,#vel_0_ai   ;;angulo 0
.db #vel_30_x_ai,#-vel_30_y_ai  ;;angulo 30
.db #vel_60_x_ai,#-vel_60_y_ai  ;;angulo 60

.db #vel_0_ai,#-vel_ai_default_y  ;;angulo 90
.db #-vel_60_x_ai,#-vel_60_y_ai  ;;angulo 120
.db #-vel_30_x_ai,#-vel_30_y_ai  ;;angulo 150

.db #-vel_ai_default_x,#vel_0_ai  ;;angulo 180
.db #-vel_30_x_ai,#vel_30_y_ai  ;;angulo 210 
.db #-vel_60_x_ai,#vel_60_y_ai  ;;angulo 240

.db #vel_0_ai,#vel_ai_default_y   ;;angulo 270
.db #vel_60_x_ai,#vel_60_y_ai  ;;angulo 300
.db #vel_30_x_ai,#vel_30_y_ai  ;;angulo 330
velocidades_ai_end::
.db #end_of_vel_ai,#end_of_vel_ai;;Para controlar el final

.area _CODE

ai_sys_init::
    .db 0xED, 0xFF
    call entity_man_get_ia_to_ix
    ld hl, #checkpoint_a_comprobar
    ld a,car_checkpoint_siguiente(ix)
    ld (hl),a
    inc hl
    ld a,car_checkpoint_siguiente+1(ix)
    ld (hl),a

    ld hl,#velocidades_ai
    ex de,hl
    ld hl,#current_ai_vel
    ld (hl),e
    inc hl
    ld (hl),d

    ;.db 0xED, 0xFF
    ld a,#0
    ld (decision_ai_timer),a
    ld a,(_nivel_actual)
    cp #1
    jr nz,check_lvl_2
    
    ld a, #14
    ld (max_decision_timer),a
    ret
    check_lvl_2:
    ld a,(_nivel_actual)
    cp #2
    ret nz
    
    ld a, #13
    ld (max_decision_timer),a
ret

; ai_sys_update::
;     .db 0xED, 0xFF
;     call entity_man_get_ia_to_ix
;     call save_prev_sprite
;     call get_distancia_actual_pos
;     call get_distancia_der_pos
;     call get_distancia_izq_pos
;     call compare_all_distances
;     ; call check_giro_ai
;     ; call input_avanzar_ai
; ret

; ai_sys_update::
;     .db 0xED, 0xFF
;     call entity_man_get_ia_to_ix
;     call save_prev_sprite
;     call get_distancia_actual_pos
;     call get_distancia_der_pos
;     call get_distancia_izq_pos
;     call check_if_next_checkpoint
;     call compare_all_distances
;     call check_giro_ai
;     call input_avanzar_ai
; ret
ai_sys_update::
    ;.db 0xED, 0xFF
    call entity_man_get_ia_to_ix
    call save_prev_sprite
    call get_distancia_actual_pos
    call get_distancia_der_pos
    call get_distancia_izq_pos
    call check_if_next_checkpoint
    ld a,(decision_ai_timer)
    cp #0
    jr nz, no_decision
    call compare_all_distances
    call check_giro_ai
    no_decision:
    call input_avanzar_ai
    call avanzar_decision_timer
ret


avanzar_decision_timer:
    ld a,(max_decision_timer)
    ld d,a
    ld a,(decision_ai_timer)
    inc a
    cp d
    jr nz,asignar_timer
    ld a,#0
    asignar_timer:
    ld (decision_ai_timer),a
ret
check_if_next_checkpoint:
    call compare_all_distances
    ld a,b
    cp #0
    jr nz, check_if_next_checkpoint_left
    call entity_man_get_current_vel
    call get_distancia_igualada
    ld c,a
    jr end_if_next_checkpoint
    check_if_next_checkpoint_left:
    cp #2
    jr nz, check_if_next_checkpoint_right
    call entity_man_get_izq_vel_2
    call get_distancia_igualada
    ld c,a
    jr end_if_next_checkpoint
    check_if_next_checkpoint_right:
    call entity_man_get_der_vel_2
    call get_distancia_igualada
    ld c,a

    end_if_next_checkpoint:
    ;ld a,(distancia_actual_pos)
    ld a,car_vel_actual(ix)
    cp #1
    jr nz,check_vel_2
    ld a,c
    cp #distancia_hasta_checkpoint_comprobar_v1
    jr checkpoint_cambiar
    check_vel_2:
    cp #2
    jr nz,check_vel_3
    ld a,c
    cp #distancia_hasta_checkpoint_comprobar_v2
    jr checkpoint_cambiar
    check_vel_3:
    cp #3
    jr nz,check_vel_0
    ld a,c
    cp #distancia_hasta_checkpoint_comprobar_v3
    jr checkpoint_cambiar
    check_vel_0:
    ld a,c
    cp #0
    checkpoint_cambiar:
    ;.db 0xED, 0xFF
    jr c,cambiar_checkpoint
    ret
    ld a,(distancia_der_pos)
    cp #10
    jr c,cambiar_checkpoint
    ld a,(distancia_izq_pos)
    cp #10
    jr c,cambiar_checkpoint
    ret
    cambiar_checkpoint:
    .db 0xED, 0xFF
    ld hl, #checkpoint_a_comprobar
    ld e,(hl)
    inc hl
    ld d,(hl)
    ex de,hl
    call get_next_checkpoint_for_ai_2
    ex de,hl
    ld hl, #checkpoint_a_comprobar
    ld (hl),e
    inc hl
    ld (hl),d
    ;.db 0xED, 0xFF
ret

get_distancia_igualada:
    push hl
    ;e:x 
    ;b:y
    call get_checkpoints_coords
    pop hl
    ;c: car_x 
    ;d: car_y
    ld c, car_x(ix)
    ld a,car_w(ix)
    srl a
    add c
    ld c,a
    ld d, car_y(ix)
    ld a,car_h(ix)
    srl a
    add d
    ld d,a
    ; ld l, car_vel(ix)
    ; ld h, car_vel+1(ix)
    call get_distancia_segun_parametros_igualadas
    
ret
;;
;;INPUT
;;B: 0 para no cambiar de pos, 1 para cambiar a der, 2 para cambiar a izq
;;
check_giro_ai:
    ld a,b
    cp #0
    jr nz, comprobar_der
    ld a,#1
    ld car_pressed_avanzar(ix),a
    ; ld a,#0
    ; ld car_pressed_key(ix),a
    ret 
    comprobar_der:
    cp #1
    jr nz, comprobar_izq
    call parar_avanzar_ai
    call ai_girar_der
    ret
    comprobar_izq:
    call parar_avanzar_ai
    call ai_girar_izq
ret

ai_girar_izq:
    ld a,car_pressed_key(ix)
    cp #0
    ret nz
    call input_giros_ai_left
    call entity_man_get_izq_vel_2
    ex de,hl
    ld hl,#current_ai_vel
    ld (hl),e
    inc hl
    ld (hl),d
ret

parar_avanzar_ai:
    ld a,#0
    ld car_pressed_key(ix),a
    ld car_pressed_avanzar(ix),a
    call bajar_cont_avanzar
ret
ai_girar_der:
    ld a,car_pressed_key(ix)
    cp #0
    ret nz
    call input_giros_ai_right
    call entity_man_get_der_vel_2
    ex de,hl
    ld hl,#current_ai_vel
    ld (hl),e
    inc hl
    ld (hl),d
ret

;;
;;OUTPUT
;;B: 0 para no cambiar de pos, 1 para cambiar a der, 2 para cambiar a izq
;;
compare_all_distances:
    ld b,#0
    ld a,(distancia_der_pos)
    ld c,a
    ld a,(distancia_actual_pos)
    cp c
    jr c, comprobar_siguiente
    ;jr z, comprobar_siguiente
    ld a,c
    ld b,#1
    comprobar_siguiente:
    ld d,a
    ld a,(distancia_izq_pos)
    ld c,a
    ld a,d
    cp c
    ret c
    ;ret z
    ld b,#2
ret

get_distancia_actual_pos:
    ;e:x 
    ;b:y
    ; ld e,#70
    ; ld b,#49
    ;call get_checkpoints_for_ai
    call get_checkpoints_coords
    ;c: car_x 
    ;d: car_y
    ld c, car_x(ix)
    ld a,car_w(ix)
    srl a
    add c
    ld c,a
    ld d, car_y(ix)
    ld a,car_h(ix)
    srl a
    add d
    ld d,a

    call entity_man_get_current_vel
    ; ld l, car_vel(ix)
    ; ld h, car_vel+1(ix)
    call get_distancia_segun_parametros_igualadas
    ld (distancia_actual_pos),a
ret

;;
;;OUTPUT
;;e:CHECKPOINT X
;;b:CHECKPOINT Y
;;
get_checkpoints_coords:
  ;e:x 
  ;b:y
  ld hl,(checkpoint_a_comprobar)
;   inc hl
;   ld h,(hl)
;   ld a,(checkpoint_a_comprobar)
;   ld l,a
  ld e,(hl);;checkpoint x
  inc hl
  ld b,(hl);;checkpoint y
  inc hl
  ld a,(hl);;checkpoint w
  srl a    ;;checkpoint w/2
  add e    ;;checkpoint x+(w/2)
  ld e,a 
  inc hl  
  ld a,(hl);;checkpoint h
  srl a    ;;checkpoint h/2
  add b    ;;checkpoint y+(h/2)
  ld b,a
ret

get_distancia_der_pos:
    call entity_man_get_der_vel_2
    push hl
    ;e:x 
    ;b:y
    ;call get_checkpoints_for_ai
    call get_checkpoints_coords
    pop hl
    ;c: car_x 
    ;d: car_y
    ld c, car_x(ix)
    ld a,car_w(ix)
    srl a
    add c
    ld c,a
    ld d, car_y(ix)
    ld a,car_h(ix)
    srl a
    add d
    ld d,a
    
    call get_distancia_segun_parametros_igualadas
    ld (distancia_der_pos),a
ret

get_distancia_izq_pos:
    call entity_man_get_izq_vel_2
    push hl
    ;e:x 
    ;b:y
    ;call get_checkpoints_for_ai
    call get_checkpoints_coords
    pop hl
    ;c: car_x 
    ;d: car_y
    ld c, car_x(ix)
    ld a,car_w(ix)
    srl a
    add c
    ld c,a
    ld d, car_y(ix)
    ld a,car_h(ix)
    srl a
    add d
    ld d,a
    
    call get_distancia_segun_parametros_igualadas
    ld (distancia_izq_pos),a
ret
entity_man_get_current_vel:
    ld hl,#current_ai_vel
    ld a,(hl)
    inc hl
    ld h,(hl)
    ld l,a
ret
entity_man_get_izq_vel_2:
    call entity_man_get_current_vel

    ld de,#vel_size_ai
    add hl,de
    
    ld a,(hl)
    cp #end_of_vel_ai
    ret nz
    ld hl,#velocidades_ai
ret
entity_man_get_der_vel_2::
    call entity_man_get_current_vel

    ld e,#-vel_size_ai
    ld d,#0xFF
    add hl,de

    ld a,(hl)
    cp #end_of_vel_ai
    ret nz
    ld hl,#(velocidades_ai_end-vel_size_ai)
ret
;;
;; INPUT
;; b:chkpnt x
;; c:chkpnt y
;; d:car x
;; e:car y 
;; hl: car vel
;; OUTPUT
;; a:resultado a guardar
;;
get_distancia_segun_parametros:
    ;ld a, (hl)
    push de ;;guardo car x y car y en la pila
    push hl ;;guardo puntero vel
    ld e, car_x_256(ix) ;;de: carx,carx256
    ;call get_x_or_y_with_vel_ai
    pop hl ;;recupero puntero vel
    ld a,d
    pop de ;recupero car x y car y de la pila
    ld d,a ;; d: car x + vel x

    ld a,b;;a= chkpoint x
    sub d ;;a= chkpoint x-car x + vel x
    ld b, a ;;c= chkpoint x-car x + vel x
    and #0b10000000
    jr z,no_neg
    ld a,b
    neg
    ld b, a
    no_neg:
    ;;b= chkpoint x-car x + vel x
    ;;e= car y
    ;;hl= punt vel
    ;;COMPROBAR Y
    inc hl
    ld d,e
    ld e, car_y_256(ix) ;;de: cary,cary256
    ;call get_x_or_y_with_vel_ai
    ld e,d ;; e: car y + vel y

    ld a,c;;a= chkpoint y
    sub e ;;a= chkpoint y-car y + vel y
    ld h,a;;h= chkpoint y-car y + vel y
    and #0b10000000
    jr z,no_neg2
    ld a,h
    neg
    ld h, a
    no_neg2:
    ld a,b ;;a= chkpoint x-car x + vel x
    add h ;;a= chkpoint x-car x + vel x + chkpoint y-car y + vel y
ret

;;
;; INPUT
;; e:chkpnt x
;; b:chkpnt y
;; c:car x
;; d:car y 
;; hl: car vel
;; OUTPUT
;; a:resultado a guardar
;;
; get_distancia_segun_parametros_igualadas:
;     ld a, (hl)
;     add c ;;a= car x + vel x
;     ld c,a;;c= car x + vel x
;     ld a,e;;a= chkpoint x
;     sub c ;;a= chkpoint x-car x + vel x
;     ld c,a
;     and #0b10000000
;     jr z,no_neg_2
;     ld a,c
;     neg
;     ld c, a
;     no_neg_2:
;     ld a,c
;     ;sla a
;     add a
;     ld c, a ;;c= (chkpoint x-car x + vel x)/2
;     inc hl
;     ld a, (hl);;a= vel y
;     add d ;;a= car y + vel y
;     ld d,a;;d= car y + vel y
;     ld a,b;;a= chkpoint y
;     sub d ;;a= chkpoint y-car y + vel y
;     ld h,a;;h= chkpoint y-car y + vel y
;     and #0b10000000
;     jr z,no_neg2_2
;     ld a,h
;     neg
;     ld h, a
;     no_neg2_2:
;     ld a,c ;;a= chkpoint x-car x + vel x
;     add h ;;a= chkpoint x-car x + vel x + chkpoint y-car y + vel y
; ret

;;
;; INPUT
;; e:chkpnt x
;; b:chkpnt y
;; c:car x
;; d:car y 
;; hl: car vel
;; OUTPUT
;; a:resultado a guardar
;;
get_distancia_segun_parametros_igualadas:
    ld a, (hl)
    add c ;;a= car x + vel x
    ld c,a;;c= car x + vel x
    ld a,e;;a= chkpoint x
    sub c ;;a= chkpoint x-car x + vel x
    ld c,a
    and #0b10000000
    jr z,no_neg_2
    ld a,c
    neg
    ld c, a
    no_neg_2:
    ld a,c
    ;sla a
    add a
    ld c, a ;;c= (chkpoint x-car x + vel x)/2
    inc hl
    ld a, (hl);;a= vel y
    add d ;;a= car y + vel y
    ld d,a;;d= car y + vel y
    ld a,b;;a= chkpoint y
    sub d ;;a= chkpoint y-car y + vel y
    ld h,a;;h= chkpoint y-car y + vel y
    and #0b10000000
    jr z,no_neg2_2
    ld a,h
    neg
    ld h, a
    no_neg2_2:
    ld a,c ;;a= chkpoint x-car x + vel x
    add h ;;a= chkpoint x-car x + vel x + chkpoint y-car y + vel y
ret