;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "collision_sys.inc"
.include "man/entity_man.inc"
.include "physics_sys.inc"
.include "render_sys.inc"
.include "man/referencia_man.inc"

.area _DATA
comprobar_u_l:.db 0
comprobar_u_r:.db 0
comprobar_d_l:.db 0
comprobar_d_r:.db 0

.area _CODE
check_iguales: .db 0

 choque_effect_init::
     ld de, #_choqueSFX
     call cpct_akp_musicInit_asm
 ret
get_tile_up_left:
    ;;arriba izq
    ld a,car_x(ix) 
    inc a
    ld d,car_y(ix) 
    inc d
    call calculate_address_of_tile
    ld a,(iy)
    ld  car_id_tile_up_left(ix),a
ret

get_tile_up_right:
    ;;arriba der

    ld a,car_x(ix) 
    add #4
    ld d,car_y(ix) 
    inc d
    call calculate_address_of_tile
    ld a,(iy)
    ld  car_id_tile_up_right(ix),a
ret

get_tile_down_left:
    ;;abajo izq
    ld a,car_y(ix) 
    add #9
    ld d,a
    ld a,car_x(ix) 
    inc a
    call calculate_address_of_tile
    ld a,(iy)
    ld  car_id_tile_down_left(ix),a
ret

get_tile_down_right:
    ;;abajo der
    ld a,car_y(ix) 
    add #9
    ld d,a
    ld a,car_x(ix) 
    add #4
    call calculate_address_of_tile
    ld a,(iy)
    ld  car_id_tile_down_right(ix),a
ret
get_all_tile_ids:
    ;;arriba izq
    call get_tile_up_left
    ;;arriba der
    call get_tile_up_right
    ;;abajo izq
    call get_tile_down_left
    ;;abajo der
    call get_tile_down_right
    
ret
get_tile_x_left:
    ld  a, car_x(ix) ;; A = car.x
    inc a
    srl a            ;; A = car.x / 2
    srl a            ;; A = car.x / 4
    ld  car_tile_x_left(ix),a
ret
get_tile_x_right:
    ld  a, car_x(ix) ;; A = car.x
    add #4
    ;dec a
    srl a            ;; A = car.x+10 / 2
    srl a            ;; A = car.x+10 / 4
    ld  car_tile_x_right(ix),a
ret

get_tile_y_up:
    ld  a, car_y(ix) ;; A = car.y
    inc a
    srl a            ;; A = car.y / 2
    srl a            ;; A = car.y / 4
    srl a            ;; A = car.y / 8
    ld  car_tile_y_up(ix),a
ret

get_tile_y_down:
    ld  a, car_y(ix) ;; A = car.y
    add #9
    ;dec a
    srl a            ;; A = car.y+10 / 2
    srl a            ;; A = car.y+10 / 4
    srl a            ;; A = car.y+10 / 8
    ld  car_tile_y_down(ix),a
ret
sys_collision_init::
    call get_all_tile_ids
    call get_tile_x_left
    call get_tile_x_right
    call get_tile_y_up
    call get_tile_y_down

ret

check_tile_x_izq:
    ld  a, car_x(ix) ;; A = car.x
    inc a
    srl a            ;; A = car.x / 2
    srl a            ;; A = car.x / 4
    ld b,a
    ld  a,car_tile_x_left(ix)
    cp b
ret
check_left:
    ld  d, car_tile_x_left(ix)
    call get_tile_x_left
    cp d   
    ret z 
    ld a,#1
    ld (comprobar_u_l),a
    ld (comprobar_d_l),a
ret
check_up:
    ld  d, car_tile_y_up(ix)
    call get_tile_y_up
    cp d   
    ret z 
    ld a,#1
    ld (comprobar_u_l),a
    ld (comprobar_u_r),a
ret
check_down:
    ld  d, car_tile_y_down(ix)
    call get_tile_y_down
    cp d   
    ret z 
    ld a,#1
    ld (comprobar_d_l),a
    ld (comprobar_d_r),a
ret
check_right:
    ld  d, car_tile_x_right(ix)
    call get_tile_x_right
    cp d   
    ret z 
    ld a,#1
    ld (comprobar_u_r),a
    ld (comprobar_d_r),a
ret
check_all_coords:

    ld a,#0
    ld (comprobar_u_l),a
    ld (comprobar_u_r),a
    ld (comprobar_d_l),a
    ld (comprobar_d_r),a
    call check_left
    call check_right
    call check_up
    call check_down
    ld a,(comprobar_u_l)
    or a
    jr z,comp_u_r
    call get_tile_up_left
    comp_u_r:
    ld a,(comprobar_u_r)
    or a
    jr z,comp_d_l
    call get_tile_up_right
    comp_d_l:
    ld a,(comprobar_d_l)
    or a
    jr z,comp_d_r
    call get_tile_down_left
    comp_d_r:
    ld a,(comprobar_d_r)
    or a
    jr z,end_comprobar
    call get_tile_down_right
    end_comprobar:
ret

colision_up_left:;;detectada colision con tile arr izq
    ld  a,car_id_tile_up_right(ix)
    cp #id_meta
    jr z, col_up_left_down_left
    or a
    jr z, col_up_left_down_left
    call nz,undo_last_movement_up_down;;colision  arr izq + arr der
    ret
    col_up_left_down_left:
    ld  a,car_id_tile_down_left(ix)
    cp #id_meta
    jr z, col_up_left
    or a
    jr z,col_up_left
    call nz,undo_last_movement_left_right;;colision  arr izq + abajo izq
    ret
    col_up_left:
    call check_collision_up_left
    call stop_car_collision
ret

colision_up_right:;;detectada colision con tile arr der
    ld  a,car_id_tile_up_left(ix)
    cp #id_meta
    jr z, col_up_right_down_right
    or a
    jr z, col_up_right_down_right
    call nz,undo_last_movement_up_down;;colision  arr der + arr izq
    ret
    col_up_right_down_right:
    ld  a,car_id_tile_down_right(ix)
    cp #id_meta
    jr z, col_up_right
    or a
    jr z,col_up_right
    call nz,undo_last_movement_left_right;;colision  arr der + abajo der
    ret
    col_up_right:
    call check_collision_up_right
    call stop_car_collision
ret

colision_down_left:
    ld  a,car_id_tile_up_left(ix)
    cp #id_meta
    jr z, col_down_left_down_right
    or a
    jr z,col_down_left_down_right
    call nz,undo_last_movement_left_right ;;colision  arr izq + abajo izq
    ret
    col_down_left_down_right:
    ld  a,car_id_tile_down_right(ix)
    cp #id_meta
    jr z, col_down_left
    or a
    jr z,col_down_left
    call nz,undo_last_movement_up_down ;;colision  abajo izq + abajo der
    ret
    col_down_left:
    call check_collision_down_left
    call stop_car_collision
ret

colision_down_right:
    ld  a,car_id_tile_down_left(ix)
    cp #id_meta
    jr z, col_down_right_up_right
    or a
    jr z,col_down_right_up_right
    call nz,undo_last_movement_up_down ;;colision abajo der + abajo izq
    ret
    col_down_right_up_right:
    ld  a,car_id_tile_up_right(ix)
    cp #id_meta
    jr z, col_down_right
    or a
    jr z,col_down_right
    call nz,undo_last_movement_left_right ;;colision  arr der + abajo der
    col_down_right:
    call check_collision_down_right
    call stop_car_collision
ret
sys_collision_update_one_entity:
    call hay_col_sobre
    cp #0
    jr z,no_col_sobre
    call check_collision_sobre
    no_col_sobre:

    ld a,car_collision_cont(ix)
    ld (check_iguales),a

    ; ld hl,#0xC000
    ; ld (hl),#0xFF
    call check_all_coords

    ;;COL UP LEFT
    ld  a,car_id_tile_up_left(ix)
    cp #id_meta
    jr z, else_id_up_right
    or a
    jr z,else_id_up_right

    call colision
    call colision_up_left
    jr end_check_collisions

    ;;COL UP RIGHT
    else_id_up_right:
    ld  a,car_id_tile_up_right(ix)
    cp #id_meta
    jr z, else_id_down_left
    or a
    jr z,else_id_down_left

    call colision
    call colision_up_right
    jr end_check_collisions


    ;;COL DOWN LEFT
    else_id_down_left:
    ld  a,car_id_tile_down_left(ix)
    cp #id_meta
    jr z, else_id_down_right
    or a
    jp z,else_id_down_right

    call colision
    call colision_down_left
    jr end_check_collisions

    ;;COL DOWN RIGHT
    else_id_down_right:
    ld  a,car_id_tile_down_right(ix)
    cp #id_meta
    ; ret z
    jr z,end_check_collisions
    or a
    jp z,end_check_collisions

    call colision
    call colision_down_right
    end_check_collisions:
    ld iy,#return_entity_man_all_entities
    jp (iy)
ret
sys_collision_update::
    ld iy,#sys_collision_update_one_entity
    call entity_man_all_entities
ret
colision: ;; BORRAR pinta esquina para saber si hay colision
    ; ld hl,#0xC000
    ; ld (hl),#0x33
    push de
     call choque_effect_init
     call cpct_waitVSYNC_asm
     call cpct_akp_musicPlay_asm
    pop de
ret

;;
;; INPUT
;; c:car x
;; d:car y 
;; OUTPUT
;; e: chkpoint x
;; b: chkpoint y
calculate_coords_of_tile:
    ; .db 0xED, 0xFF
    ld a, c
    and #0b11111000
    ld e,a;;e= chkpoint x
    ld a,d
    and #0b11111000
    ld b,a;;b= chkpoint y
ret

;; INPUT
;; e: chkpoint x
;; b: chkpoint y
;; OUTPUT
;; e: chkpoint x
;; b: chkpoint y + 8
get_coords_down:
    ld a,b
    add #8
    ld b,a
ret

;; INPUT
;; e: chkpoint x
;; b: chkpoint y
;; OUTPUT
;; e: chkpoint x + 8
;; b: chkpoint y 
get_coords_right:
    ld a,e
    add #8
    ld e,a
ret

;; INPUT
;; e: chkpoint x
;; b: chkpoint y
;; OUTPUT
;; e: chkpoint x 
;; b: chkpoint y - 8
get_coords_up:
    ld a,b
    sub #8
    ld b,a
ret

;; INPUT
;; e: chkpoint x
;; b: chkpoint y
;; OUTPUT
;; e: chkpoint x - 8
;; b: chkpoint y 
get_coords_left:
    ld a,e
    sub #8
    ld e,a
ret
;;
;; INPUT
;; e: chkpoint x
;; b: chkpoint y
;; c:car x
;; d:car y 
;; OUTPUT
;; a:resultado a guardar
;;
get_distancia_segun_parametros_collision:
    ld a,e;;a= chkpoint x
    sub c ;;a= chkpoint x-car x 
    ld c, a ;;c= chkpoint x-car x
    and #0b10000000
    jr z,no_neg
    ld a,c
    neg
    ld c, a
    no_neg:
    ld a,b;;a= chkpoint y
    sub d ;;a= chkpoint y-car y 
    ld d,a;;d= chkpoint y-car y
    and #0b10000000
    jr z,no_neg2
    ld a,d
    neg
    ld d, a
    no_neg2:
    ld a,c ;;a= chkpoint x-car x 
    add d ;;a= chkpoint x-car x  + chkpoint y-car y 
ret

;; e: chkpoint x
;; b: chkpoint y
draw_coll:
  
  ld c,e
  ld de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
  call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
  
  ex de,hl
  ld a,#4
  ld b,a
  ld a,#2
  ld c,a
  ld a,#0x44
  call cpct_drawSolidBox_asm
ret
check_collision_up_left:
    
    ld l,car_vel(ix)
    ld h,car_vel+1(ix)

    ld a,(hl)
    and #0b10000000
    cp #0
    jr nz,up_left_check_y
    ld b,#4
    ld a,car_y(ix)
    add b
    ld car_y(ix),a
    ret
    up_left_check_y:
    inc hl
    ld a,(hl)
    and #0b10000000
    cp #0
    jr nz,up_left_sumar_y
    ld b,#2
    ld a,car_x(ix)
    add b
    ld car_x(ix),a
    ret
    up_left_sumar_y:
    ld a,car_y(ix)
    add #2
    ld car_y(ix),a
ret

check_collision_up_right:
    ld l,car_vel(ix)
    ld h,car_vel+1(ix)

    ld a,(hl)
    and #0b10000000
    cp #0
    jr z,up_right_check_y
    ld b,#4
    ld a,car_y(ix)
    add b
    ld car_y(ix),a
    ret
    up_right_check_y:
    inc hl
    ld a,(hl)
    and #0b10000000
    cp #0
    jr nz,up_right_restar_x
    ld b,#2
    ld a,car_x(ix)
    sub b
    ld car_x(ix),a
    ret
    up_right_restar_x:
    ld a,car_x(ix)
    sub #2
    ld car_x(ix),a
ret


check_collision_down_left: 
    ld l,car_vel(ix)
    ld h,car_vel+1(ix)

    ld a,(hl)
    and #0b10000000
    cp #0
    jr nz,down_left_check_y
    ld b,#4
    ld a,car_y(ix)
    sub b
    ld car_y(ix),a
    ret
    down_left_check_y:
    inc hl
    ld a,(hl)
    and #0b10000000
    cp #0
    jr z,down_left_sumar_x
    ld b,#2
    ld a,car_x(ix)
    add b
    ld car_x(ix),a
    ret
    down_left_sumar_x:
    ld a,car_x(ix)
    add #2
    ld car_x(ix),a
ret
check_collision_down_right:
    ld l,car_vel(ix)
    ld h,car_vel+1(ix)

    ld a,(hl)
    and #0b10000000
    cp #0
    jr z,down_right_check_y
    ld b,#4
    ld a,car_y(ix)
    sub b
    ld car_y(ix),a
    ret
    down_right_check_y:
    inc hl
    ld a,(hl)
    and #0b10000000
    cp #0
    jr z,down_right_restar_x
    ld b,#2
    ld a,car_x(ix)
    sub b
    ld car_x(ix),a
    ret
    down_right_restar_x:
    ld a,car_x(ix)
    sub #2
    ld car_x(ix),a

ret

abajo_der_iguales:
    ld l,car_vel(ix)
    ld h,car_vel+1(ix)
    inc hl
    ld a,(hl)
    and #0b10000000
    cp #0
    jr nz,movimiento_hacia_arriba
    call undo_last_movement_up_down
    ret
    movimiento_hacia_arriba:
    call undo_last_movement_left_right
ret
;;
;; INPUT: A - car_x
;;        D - car_y
;; OUTPUT: HL: DIRECCION AL TILE CALCULADO
;;         IY: DIRECCION AL TILE CALCULADO
;;
calculate_address_of_tile:
    ;ld  a, car_x(ix) ;; A = car.x
    ;inc a
    srl a            ;; A = car.x / 2
    srl a            ;; A = car.x / 4
    ld  c,a          ;; 
    ld  b,#0         ;; BC = car.x / 4
    ;ld  a, car_y(ix) ;; A = car.y
    ld  a, d ;; A = car.y
    ;inc a
    and #0b11111000  ;; A = 8 * int( car.y / 8 )
    ld  e,a          ;; 
    srl e            ;; DE = 4 * int( car.y / 8 )
    ld  d,b          ;; 
    ld  l,a          ;; 
    ld  h,d          ;; HL = A = 8 * int( car.y / 8 )
    add hl,hl        ;; HL = 16 * int( car.y / 8 )
    add hl,de        ;; HL = 20 * int( car.y / 8 )
    add hl,bc        ;; HL = 20 * int( car.y / 8 ) + (car.x / 4)
    ex  de,hl        ;; DE = 20 * int( car.y / 8 ) + (car.x / 4)
    ld hl,(_mapa_actual)
    ld iy,(_mapa_actual)
    ;ld  iy, #_level1;; IY = BASE ADDRESS
    add iy,de        ;; IY = BASE + 20 * int( car.y / 8 ) + (car.x / 4)
    ;ld  hl, #_level1;; IY = BASE ADDRESS
    add hl,de        ;; IY = BASE + 20 * int( car.y / 8 ) + (car.x / 4)
ret

; calculate_address_of_tile:
;     ld  a, car_x(ix) ;; A = car.x
;     inc a
;     srl a            ;; A = car.x / 2
;     srl a            ;; A = car.x / 4
;     ld  c,a          ;; 
;     ld  b,#0         ;; BC = car.x / 4
;     ld  a, car_y(ix) ;; A = car.y
;     inc a
;     and #0b11111000  ;; A = 8 * int( car.y / 8 )
;     ld  e,a          ;; 
;     srl e            ;; DE = 4 * int( car.y / 8 )
;     ld  d,b          ;; 
;     ld  l,a          ;; 
;     ld  h,d          ;; HL = A = 8 * int( car.y / 8 )
;     add hl,hl        ;; HL = 16 * int( car.y / 8 )
;     add hl,de        ;; HL = 20 * int( car.y / 8 )
;     add hl,bc        ;; HL = 20 * int( car.y / 8 ) + (car.x / 4)
;     ex  de,hl        ;; DE = 20 * int( car.y / 8 ) + (car.x / 4)
;     ld  iy, #_level1;; IY = BASE ADDRESS
;     add iy,de        ;; IY = BASE + 20 * int( car.y / 8 ) + (car.x / 4)

; ret

check_collision_sobre:
    ld d,#sobre_coords_x_1
    ld c,#4 ;;w sobre

    ld a,car_x(ix)
    add car_w(ix);; a= car x + car_w
    sub #1
    cp d ;;car_x + car_w > chk point x
    jr c,end_collision_sobre


    ld a,car_x(ix)
    ;add car_w(ix)
    ld b,a  ;; b= car x
    ld a,d ;; a= chk point x
    add c
    sub #1
    cp b ;;car_x < chk point x + chk point w
    jr c,end_collision_sobre


    ld d,#sobre_coords_y_1
    ld c,#8 ; h sobre

    ld a,car_y(ix)
    add car_h(ix);; a= car y + car_h
    sub #1
    cp d ;;car_y + car_H > chk point y
    jr c,end_collision_sobre

    ld a,car_y(ix)
    ;add car_h(ix)
    ld b,a  ;; b= car y
    ld a,d ;; a= chk point y
    add c
    sub #1
    cp b ;;car_y < chk point y + chk point h
    jr c,end_collision_sobre

    call quitar_sobre

    end_collision_sobre:

ret