;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "input_sys.inc"
.include "man/entity_man.inc"
.include "man/animation_man.inc"
.include "physics_sys.inc"

.area _DATA


pressed_key::.db #0
pressed_avanzar::.db 0

contador_pintar:.db 0
.area _CODE
input::
   ld ix,#c_components
   call save_prev_sprite
   call cpct_scanKeyboard_asm
   call cpct_isAnyKeyPressed_asm
   jr nz,tecla_pulsada
   ld a,#0
   ld car_pressed_key(ix),a
   ld car_pressed_avanzar(ix),a
   call bajar_cont_avanzar
   ret
   tecla_pulsada:
   ld a,car_pressed_key(ix)
   cp #0
   jr nz,letra_ya_presionada
   call input_giros
   letra_ya_presionada:
   call check_contador_giros
   ld a,#0
   ld car_pressed_avanzar(ix),a
   ld hl,#Key_Q
   call cpct_isKeyPressed_asm
   jr nz,pressed_avanzar_key
   
   ld hl,#Joy0_Fire1
   call cpct_isKeyPressed_asm
   jr z,avanzar_no_pressed
   pressed_avanzar_key:
   ld a,#1
   ld car_pressed_avanzar(ix),a
   call subir_cont_avanzar
   ;call movimiento_coche
   ret
   avanzar_no_pressed:
   call bajar_cont_avanzar
   ret

subir_cont_avanzar:
   ld a, car_contador_avanzar(ix)
   inc a
   ld b,a
   ld car_contador_avanzar(ix),a
   ld a, car_vel_actual(ix)
   cp #3
   ret nz
   ld a,b
   cp #max_contador_avanzar+1
   ret nz
   ld a,#max_contador_avanzar
   ld car_contador_avanzar(ix),a
ret
bajar_cont_avanzar::
   ld a, car_contador_avanzar(ix)
   ld b,a
   dec a
   ld car_contador_avanzar(ix),a
   ld a, car_vel_actual(ix)
   cp #0
   ret nz
   ld a,b
   cp #0
   ret nz
   ld a,#0
   ld car_contador_avanzar(ix),a
ret
input_giros::
   ld hl,#Key_O
   call cpct_isKeyPressed_asm
   jr z,left_keyboard_no_pressed
   call giro_izq
   ret
   left_keyboard_no_pressed:
   ld hl,#Joy0_Left
   call cpct_isKeyPressed_asm
   jr z,left_no_pressed
   call giro_izq
   ret
   left_no_pressed:
   ld hl,#Key_P
   call cpct_isKeyPressed_asm
   jr z,right_keyboard_no_pressed
   call giro_der
   ret
   right_keyboard_no_pressed:
   ld hl,#Joy0_Right
   call cpct_isKeyPressed_asm
   ret z
   call giro_der
   ret

input_giros_ai_left::
   call giro_izq
ret

input_giros_ai_right::
   call giro_der
ret
   
input_avanzar_ai::
   call check_contador_giros
   ld a,#1
   ld car_pressed_avanzar(ix),a
   call subir_cont_avanzar
ret