;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "physics_sys.inc"
.include "man/entity_man.inc"
.include "man/animation_man.inc"
.include "input_sys.inc"
.area _CODE

sys_physics_update::
   ;call movimiento_coche
   ld iy,#movimiento_coche
   call entity_man_all_entities
ret

acelerar_vel::
   ld a,car_vel_actual(ix)
   cp #3
   ret z 
   ld a,car_pressed_avanzar(ix)
   cp #0
   ret z 
   
   ld a,car_vel_actual(ix)
   ld car_vel_punt(ix),a
   inc a
   ld car_vel_actual(ix),a
   cp #1
   ret z
   ; cp #1
   ; jr nz, igualar_punt
   ; ld a,#0
   ; igualar_punt:
   ; ld car_vel_punt(ix),a

   ld l,car_vel(ix)
   ld h,car_vel+1(ix)
   inc hl
   inc hl
   ld car_vel(ix),l
   ld car_vel+1(ix),h

   ret

bajar_vel::
   ld a,car_vel_punt(ix)
   cp #0
   jr z,check_vel_actual
   jr change_vel

   check_vel_actual:
   ld a,car_vel_actual(ix)
   cp #0
   ret z 

   change_vel:
   ld a,car_vel_actual(ix)
   dec a
   ld car_vel_actual(ix),a
   cp #0
   jr nz, restar_punt
   ld a,#0
   jr igualar_punt_b
   restar_punt:
   dec a
   igualar_punt_b:
   ld car_vel_punt(ix),a

   ld a,car_vel_actual(ix)
   cp #0
   ret z 

   ld l,car_vel(ix)
   ld h,car_vel+1(ix)
   dec hl
   dec hl
   ld car_vel(ix),l
   ld car_vel+1(ix),h
   ret
; movimiento_coche::
;    ;ld ix,#c_components
;    ld a,car_vel_actual(ix)
;    cp #0
;    jr z,check_car_movement

;    ld l,car_vel(ix)
;    ld h,car_vel+1(ix)
;    ld a,(hl)
;    ld b,a
;    ld a,car_x(ix)
;    add b
;    ld car_x(ix),a

;    inc hl
;    ld a,(hl)
;    ld b,a
;    ld a,car_y(ix)
;    add b
;    ld car_y(ix),a
   
;    check_car_movement:
;    call check_pressed_avanzar
;     ;;comprobar si se esta pulsando la tecla de avanzar
;    ld a,car_pressed_avanzar(ix)
;    cp #0
;    jr z,frenar
;    jr acelerar
;    frenar:
;    ld a,car_contador_avanzar(ix)
;    cp #0
;    jr nz,volver_physics_update
;    ld a,#max_contador_avanzar
;    ld car_contador_avanzar(ix),a
;    call bajar_vel
;    jr volver_physics_update
;    acelerar:
;    ld a,car_contador_avanzar(ix)
;    cp #max_contador_avanzar
;    jr nz,volver_physics_update
;    ld a,#0
;    ld car_contador_avanzar(ix),a
;    call acelerar_vel

;    volver_physics_update:
;    ld iy,#return_entity_man_all_entities
;    jp (iy)
;    ret
movimiento_coche::
   ;ld ix,#c_components
   ld a,car_vel_actual(ix)
   cp #0
   jr z,check_car_movement

   ld l,car_vel(ix)
   ld h,car_vel+1(ix)
   ld a,(hl)
   and #0b10000000
   cp #0
   ld d,#0
   jr z,no_add_neg
   ld d,#0xff
   no_add_neg:
   ld e,(hl)
   ex de,hl
   ld c,l
   ld b,h
   ld l,car_x_256(ix)
   ld h,car_x(ix)
   add hl,bc
   add hl,bc
   ld car_x_256(ix),l
   ld car_x(ix),h

   ex de,hl
   inc hl
   ld a,(hl)
   and #0b10000000
   cp #0
   ld d,#0
   jr z,no_add_neg_2
   ld d,#0xff
   no_add_neg_2:
   ld e,(hl)
   ex de,hl
   ld c,l
   ld b,h
   ld l,car_y_256(ix)
   ld h,car_y(ix)
   ; ld c,car_y_256(ix)
   ; ld b,car_y(ix)
   add hl,bc
   add hl,bc
   add hl,bc
   ld car_y_256(ix),l
   ld car_y(ix),h
   
   check_car_movement:
   call check_pressed_avanzar
    ;;comprobar si se esta pulsando la tecla de avanzar
   ld a,car_pressed_avanzar(ix)
   cp #0
   jr z,frenar
   jr acelerar
   frenar:
   ld a,car_contador_avanzar(ix)
   cp #0
   jr nz,volver_physics_update
   ld a,#max_contador_avanzar
   ld car_contador_avanzar(ix),a
   call bajar_vel
   jr volver_physics_update
   acelerar:
   ld a,car_contador_avanzar(ix)
   cp #max_contador_avanzar
   jr nz,volver_physics_update
   ld a,#0
   ld car_contador_avanzar(ix),a
   call acelerar_vel

   volver_physics_update:
   ld iy,#return_entity_man_all_entities
   jp (iy)
   ret
giro_der::
   ld l,car_vel(ix)
   ld h,car_vel+1(ix)
   ld e,#-vel_size
   ld d,#0xFF
   add hl,de

   ld a,(hl)
   cp #end_of_vel
   jr nz,igualar_vel_der
   ld hl,#(velocidades_end-vel_size)
   ld a,car_vel_punt(ix)
   add a
   ld c,a
   ld b,#0
   add hl,bc
   igualar_vel_der:
   ld car_vel(ix),l
   ld car_vel+1(ix),h

   call giro_der_anim
   ret

giro_izq::
   ld l,car_vel(ix)
   ld h,car_vel+1(ix)
   ld e,#vel_size
   ld d,#0
   add hl,de
   
   ld a,(hl)
   cp #end_of_vel
   jr nz,igualar_vel_izq
   ld hl,#velocidades
   ld a,car_vel_punt(ix)
   add a
   ld c,a
   ld b,#0
   add hl,bc
   igualar_vel_izq:
   ld car_vel(ix),l
   ld car_vel+1(ix),h
   call giro_izq_anim
   ret


;;
;;INPUT
;;de: carx_y,carx_y256
;;HL: PUNT VEL
;;NO MODIFICAR: BC
;;OUTPUT
;;D: CAR X OR Y WITH VEL

get_x_with_vel_ai::
   ld a,(hl);;vel 
   and #0b10000000
   cp #0
   ld a,#0
   jr z,no_add_neg_x_ai
   ld a,#0xff
   no_add_neg_x_ai:
   ld l,(hl);;l: vel 
   ld h,a
   ;;hl: cant a sumar de vel 
   ;;de:carx_y,car256
   ex de,hl
   ;;de: cant a sumar
   ;;hl:carx_y,car256
   add hl,de
   add hl,de
   ex de,hl

ret

get_y_with_vel_ai::
   ld a,(hl);;vel 
   and #0b10000000
   cp #0
   ld a,#0
   jr z,no_add_neg_y_ai
   ld a,#0xff
   no_add_neg_y_ai:
   ld l,(hl);;l: vel 
   ld h,a
   ;;hl: cant a sumar de vel 
   ;;de:carx_y,car256
   ex de,hl
   ;;de: cant a sumar
   ;;hl:carx_y,car256
   add hl,de
   add hl,de
   add hl,de
   add hl,de
   add hl,de
   add hl,de
   ex de,hl

ret
; get_x_or_y_with_vel_ai::
;    ld a,(hl);;vel 
;    and #0b10000000
;    cp #0
;    ld a,#0
;    jr z,no_add_neg_x_ai
;    ld a,#0xff
;    no_add_neg_x_ai:
;    ld l,(hl);;l: vel 
;    ld h,a
;    ;;hl: cant a sumar de vel 
;    ;;de:carx_y,car256
;    ex de,hl
;    ;;de: cant a sumar
;    ;;hl:carx_y,car256
;    add hl,de
;    add hl,de
;    ex de,hl

; ret

undo_last_movement_up_down::
   ld l,car_vel(ix)
   ld h,car_vel+1(ix)
   call undo_advance_x
   ld a,car_vel_actual(ix)
   cp #0
   jr nz,no_add_up_down
   ld a,#2
   no_add_up_down:
   ld b,a
   ;ld b,car_vel_actual(ix)
   
   inc hl
   ld a,(hl)
   and #0b10000000
   cp #0
   ld a,b
   jr nz, no_neg_y
   neg
   no_neg_y:
   ld b,a
   ld a,car_y(ix)
   add b
   add b
   ;sub b
   ld car_y(ix),a
   call stop_car_collision
ret

undo_advance_x:
   ld a,(hl);;vel x
   cp #0
   ret z
   ld a,car_vel_actual(ix)
   call check_if_vel_x_is_3
   ld b,a
   ;ld b,car_vel_actual(ix)
   ld a,(hl);;vel x
   and #0b10000000
   cp #0
   jr z, no_neg_undo_advance_x
   ld a,b
   neg
   ld b,a
   no_neg_undo_advance_x:

   ld a,car_x(ix)
   add b
   ;dec a
   ld car_x(ix),a
ret
undo_advance_y:
   ld a,(hl);;vel y
   cp #0
   ret z
   ld b,car_vel_actual(ix)
   ;ld b,a
   ;ld b,car_vel_actual(ix)
   ld a,(hl);;vel y
   and #0b10000000
   cp #0
   jr z, no_neg_undo_advance_y
   ld a,b
   neg
   ld b,a
   no_neg_undo_advance_y:

   ld a,car_y(ix)
   add b
   ;dec a
   ld car_y(ix),a
ret
check_if_vel_x_is_3:
   cp #3
   ret nz
   ld a,#2
ret
check_if_vel_x_is_1:
   cp #1
   ret nz
   ld a,#2
ret
undo_last_movement_left_right::

   ld l,car_vel(ix)
   ld h,car_vel+1(ix)
   ;call undo_advance_x
   ;ld b,car_vel_actual(ix)
   ;ld a,car_vel_actual(ix)
   ;call check_if_vel_x_is_1
   ld e,#2
   ld a,(hl)
   and #0b10000000
   cp #0
   ;ld e,car_vel_actual(ix)
   jr nz, no_neg_x
   ld a,e
   neg
   ld e,a
   no_neg_x:
   ;ld b,e
   ld a,car_x(ix)
   add e
   ;sub b
   ld car_x(ix),a
   inc hl
   call undo_advance_y
   call stop_car_collision
ret

stop_car_collision::
   ld a, #0

   ld car_pressed_key(ix),a
   ld car_pressed_avanzar(ix),a

   ld car_contador_avanzar(ix),a

   ld car_vel_actual(ix),a

   ld a, car_vel_punt(ix)
   cp #0
   ret z
   ld l, car_vel(ix)
   ld h, car_vel+1(ix)
   restar_vel:
   dec hl
   dec hl
   dec a
   cp #0
   jr z,igualar_vel
   jr restar_vel
   igualar_vel:
   ld car_vel_punt(ix),a
   ld  car_vel(ix),l
   ld  car_vel+1(ix),h
ret

check_pressed_avanzar::
   ld a,car_contador_avanzar(ix)
   cp #15
   ret c
   and #0b10000000
   cp #0
   ret nz
   ld a, #max_contador_avanzar
   ld car_contador_avanzar(ix),a
   ;ld a,#1
ret

girar_derecha_ai::
   call giro_der
ret