;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of Nova Race an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Laura González Albert, Guillermo Puerta Ferrándiz, Alberto Belmonte Serna, members of Chunky Panda. 
;  Our twitter: @ChunkyPanda22
;
;  Nova Race is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  Nova Race is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "render_sys.inc"
.include "man/entity_man.inc"

.area _DATA

_mapa_actual::.dw _level1

.area _code
sys_render_init::
   ld   c, #0
   call cpct_setVideoMode_asm
   ld   hl, #_g_palette
   ld   de, #16
   call cpct_setPalette_asm
   ;cpctm_setBorder_asm HW_BLACK

   ;call sys_render_tilemap

ret
sys_render_update_first_time_each_entity:
   ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
   ld a,car_y(ix)
   ld b,a
   ld a,car_x(ix)
   ld c,a
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
   call save_prev_pos
   call draw_car
   ld iy,#return_entity_man_all_entities
   jp (iy)
ret
sys_render_update_first_time::
   ld iy,#sys_render_update_first_time_each_entity
   call entity_man_all_entities
ret
sys_render_one_entity::
   ;ld ix, #c_components
   call draw_prev_pos
   ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
   ld a,car_y(ix)
   ld b,a
   ld a,car_x(ix)
   ld c,a

   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
   call save_prev_pos
   call draw_car
   ld iy,#return_entity_man_all_entities
   jp (iy)
;ret
sys_render_update::
   ld iy,#sys_render_one_entity
   call entity_man_all_entities
   ; ld ix, #c_components
   ; call draw_prev_pos
   ; ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
   ; ld a,car_y(ix)
   ; ld b,a
   ; ld a,car_x(ix)
   ; ld c,a

   ; call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
   ; call save_prev_pos
   ; call draw_car

   ret

save_prev_pos:
   ld   car_prev_pos(ix),l
   ld   car_prev_pos+1(ix),h
   ret
draw_car:

   ex   de,hl
   push de
   ld   l,car_sprite(ix)
   ld   h,car_sprite+1(ix)
   ld   e,(hl)
   inc hl
   ld   d,(hl)
   ex de,hl
   pop de
   ld   b, #PLAYER_CAR_W
   ld   c, #PLAYER_CAR_H
   call cpct_drawSpriteBlended_asm

   ret
draw_prev_pos:

   ld   l,car_prev_sprite(ix)
   ld   h,car_prev_sprite+1(ix)
   ld   e,(hl)
   inc hl
   ld   d,(hl)
   ex de,hl
   ld   e, car_prev_pos(ix)
   ld   d, car_prev_pos+1(ix)
   ld   b, #PLAYER_CAR_W
   ld   c, #PLAYER_CAR_H
   call cpct_drawSpriteBlended_asm

   ret

sys_render_tilemap:
   ld bc, #0x1914
   ld de, #20
   ld hl, #_tiles_000
   call cpct_etm_setDrawTilemap4x8_ag_asm

   ld hl, #CPCT_VMEM_START_ASM
   ld de, (_mapa_actual)
   call cpct_etm_drawTilemap4x8_ag_asm
ret

tilemap1::

   ld hl, #(_level1)
   ld (_mapa_actual), hl

   call sys_render_tilemap 
ret
tilemap2::

   ld hl, #(_level2)
   ld (_mapa_actual), hl

   call sys_render_tilemap 
ret
tilemap3::

   ld hl, #(_level3)
   ld (_mapa_actual), hl

   call sys_render_tilemap 
   ret

;;
;;input
;;c: sobre x
;;b:sobre y
;;hl:sprite sobre
draw_sobre::
   push hl
   ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ex   de,hl
   pop hl
   ld   b, #4
   ld   c, #8
   call cpct_drawSpriteBlended_asm

   ret

pintar_cuadrados_rojos::
   ; .db 0xED, 0xFF
   ; ld l,#2
   ; ld h,#1
   ; call cpct_px2byteM0_asm
   
   ; (2B DE) screen_start	Pointer to the start of the screen (or a backbuffer)
   ; (1B C ) x	[0-79] Byte-aligned column starting from 0 (x coordinate, in bytes)
   ; (1B B ) y	[0-199] row starting from 0 (y coordinate)
   ld a,#0
   bucle_pintar_rojos:
   push af
   push hl
   ld c,(hl)
   inc hl
   ld b,(hl)
   ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL


   ; (2B DE) memory	Video memory pointer to the upper left box corner byte
   ; (1B A ) colour_pattern	1-byte colour pattern (in screen pixel format) to fill the box with
   ; (1B C ) width	Box width in bytes [1-64] (Beware!  not in pixels!)
   ; (1B B ) height	Box height in bytes (>0)

   ex   de,hl
   ld   a,#0xCC
   ld   b, #8
   ld   c, #4
   call cpct_drawSolidBox_asm

   pop hl
   inc hl
   inc hl
   pop af
   inc a
   cp #5
   jr nz,bucle_pintar_rojos
ret

pintar_cuadrado_verde::
   ; (2B DE) screen_start	Pointer to the start of the screen (or a backbuffer)
   ; (1B C ) x	[0-79] Byte-aligned column starting from 0 (x coordinate, in bytes)
   ; (1B B ) y	[0-199] row starting from 0 (y coordinate)
   ld c,(hl)
   inc hl
   ld b,(hl)
   ld   de, #CPCT_VMEM_START_ASM ;; DE = Pointer to start of the screen
   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL


   ; (2B DE) memory	Video memory pointer to the upper left box corner byte
   ; (1B A ) colour_pattern	1-byte colour pattern (in screen pixel format) to fill the box with
   ; (1B C ) width	Box width in bytes [1-64] (Beware!  not in pixels!)
   ; (1B B ) height	Box height in bytes (>0)

   ex   de,hl
   ld   a,#0xfc
   ld   b, #8
   ld   c, #4
   call cpct_drawSolidBox_asm
ret